package com.adventurer_engine.common.data.globaldata;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import by;
import com.adventurer_engine.common.data.globaldata.IGlobalData;

public class CalendarData extends IGlobalData {
  private long calendarValue = -1L;
  
  private static final String CALENDAR_VALUE_NAME = "calendarValue";
  
  private static final int TICK_EACH_HOUR = 1200;
  
  private static final int TICK_EACH_DAY = 24000;
  
  private static final int TICK_EACH_MONTH = 720000;
  
  private static final int TICK_EACH_YEAR = 8640000;
  
  public long getCalendarValue() {
    return this.calendarValue;
  }
  
  public void upDataCalendar() {
    this.calendarValue++;
    this.modified = true;
  }
  
  public void addDataCalendar(long add) {
    this.calendarValue += add;
    this.modified = true;
  }
  
  public String saveFile() {
    return "calendar_value.dat";
  }
  
  public boolean initialed() {
    return (this.calendarValue != -1L);
  }
  
  public void setDefaultValue() {
    this.calendarValue = 0L;
  }
  
  public void readNBTTagCompound(by nbt) {
    this.calendarValue = nbt.f("calendarValue");
  }
  
  public void writeNBTTagCompound(by nbt) {
    nbt.a("calendarValue", this.calendarValue);
  }
  
  public static com.adventurer_engine.common.data.globaldata.CalendarData getInstance() {
    return new com.adventurer_engine.common.data.globaldata.CalendarData();
  }
  
  public void setYear(int year) {
    this.calendarValue %= 8640000L;
    this.calendarValue += year * 8640000L;
    this.modified = true;
  }
  
  public void setMonth(int month) {
    int delta = month - getCurrentMonth();
    this.calendarValue += delta * 720000L;
    this.modified = true;
  }
  
  public void setDay(int day) {
    int delta = day - getCurrentDay();
    this.calendarValue += delta * 24000L;
    this.modified = true;
  }
  
  public void addYear(int year) {
    this.calendarValue += year * 8640000L;
    this.modified = true;
  }
  
  public void addMonth(int month) {
    this.calendarValue += month * 720000L;
    this.modified = true;
  }
  
  public void addDay(int day) {
    this.calendarValue += day * 24000L;
    this.modified = true;
  }
  
  public int getCurrentYear() {
    return (int)(this.calendarValue / 8640000L);
  }
  
  public int getCurrentMonth() {
    return (int)(this.calendarValue % 8640000L / 720000L);
  }
  
  public int getCurrentDay() {
    return (int)(this.calendarValue % 720000L / 24000L);
  }
  
  public void setDayTime(int tick) {
    this.calendarValue -= this.calendarValue % 24000L;
    this.calendarValue += (tick % 24000);
    this.modified = true;
  }
}
